<?php
class ControllerPaymentIdeallite extends Controller {

	protected function index() {
    $this->data['button_confirm'] = $this->language->get('button_confirm');
		$this->data['button_back'] = $this->language->get('button_back');

		$this->data['continue'] = HTTPS_SERVER . 'index.php?route=checkout/success';

		if ($this->request->get['route'] != 'checkout/guest/confirm') {
			$this->data['back'] = HTTPS_SERVER . 'index.php?route=checkout/payment';
		} else {
			$this->data['back'] = HTTPS_SERVER . 'index.php?route=checkout/guest';
		}

		$this->id = 'payment';

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/ideallite.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/ideallite.tpl';
		} else {
			$this->template = 'default/template/payment/ideallite.tpl';
		}
		$this->load->model('payment/ideallite');
		$this->load->language('payment/ideallite_error');

		$this->data['payment_type'] = 'ideal';
  	$this->data['merchantid'] = $this->config->get('ideallite_merchantid');
  	$this->data['subid'] = $this->config->get('ideallite_subid');

		if(strtolower($this->currency->getCode()) == strtolower($this->config->get('ideallite_currency_code_id'))) {
		  $this->data['currency_code_id'] = $this->config->get('ideallite_currency_code_id');
		} else {
      $this->session->data['error'] = $this->language->get('wrong_currency');
      $this->redirect(HTTPS_SERVER . 'index.php?route=checkout/payment');
		}

		if(strtolower($this->language->get('code') == strtolower($this->model_payment_ideallite->getLanguageById($this->config->get('ideallite_language_id'))))) {
		  $this->data['language_code'] = $this->model_payment_ideallite->getLanguageById($this->config->get('ideallite_language_id'));
		} else {
		  $this->session->data['error'] = $this->language->get('wrong_language');
		  $this->redirect (HTTPS_SERVER . 'index.php?route=checkout/payment');
		}

    $this->data['url_aquirer'] = $this->escapeHtml($this->model_payment_ideallite->get_aquirer());
    $this->data['valid_until'] = date("Y-m-d\TG:i:s\Z",strtotime ("+" . $this->config->get('ideallite_valid_days') . " hours"));
    $this->data['return_url_success'] = HTTPS_SERVER . 'index.php?route=' . $this->config->get('ideallite_return_url') . '&status=' . $this->config->get('ideallite_order_status_success_id');
    $this->data['return_url_cancel'] = HTTPS_SERVER . 'index.php?route=' . $this->config->get('ideallite_return_url') . '&status=' . $this->config->get('ideallite_order_status_cancel_id');
    $this->data['return_url_error'] = HTTPS_SERVER . 'index.php?route=' . $this->config->get('ideallite_return_url') . '&status=' . $this->config->get('ideallite_order_status_error_id');
    $this->data['order_description'] = substr($this->config->get('ideallite_order_description'), 0, 32);
    $this->data['purchaseid'] = date("Ymd") . $this->session->data['order_id'];    // use date and order_id as identifier max 16 chars
    $this->data['amount'] = round(floatval($this->model_payment_ideallite->getOrderData()),2) * 100;  // we only use the total instead of all the products
    $this->data['product_description'] = $this->model_payment_ideallite->getProductNames();

    $hashkey = $this->config->get('ideallite_hashkey');
		$hashString = $hashkey . $this->data['merchantid'] . $this->data['subid'] . $this->data['amount'] . $this->data['purchaseid'] . $this->data['payment_type'] . $this->data['valid_until'] . '1' . $this->data['product_description'] . '1' . $this->data['amount'];
		$hashString = html_entity_decode($hashString);
		$hashString = str_replace(array("\t", "\n", "\r", " "), '', $hashString);
		$this->data['hashstring'] = sha1($hashString);

    $this->data['return_to_shop'] = $this->language->get('return_to_shop');

    $this->model_payment_ideallite->setOrderStatusBeforePayment($this->session->data['order_id'], $this->config->get('ideallite_order_status_payment_start'));

		$this->render();
	}

	public function confirm() {
		if (($this->request->server['REQUEST_METHOD'] == 'GET')) {
			if(isset($this->request->get['status']) && intval($this->request->get['status']) > 1 ) {
			  switch (intval($this->request->get['status'])) {
			    case intval($this->config->get('ideallite_order_status_success_id')):
			      $this->load->model('checkout/order');
		        $this->load->model('payment/ideallite');
		        $this->model_payment_ideallite->resetOrderStatusBeforeConfirm($this->session->data['order_id']);
	          $this->model_checkout_order->confirm($this->session->data['order_id'], intval($this->config->get('ideallite_order_status_success_id')));
			      $this->redirect(HTTP_SERVER . 'index.php?route=checkout/success');
			    break;
			    case intval($this->config->get('ideallite_order_status_cancel_id')):
			      $this->load->model('checkout/order');
		        $this->load->model('payment/ideallite');
		        $this->load->language('payment/ideallite_error');
		        $this->model_payment_ideallite->resetOrderStatusBeforeConfirm($this->session->data['order_id']);
	          $this->model_checkout_order->confirm($this->session->data['order_id'], intval($this->config->get('ideallite_order_status_cancel_id')), '', FALSE);
		        $this->session->data['payment_notice'] = base64_encode(serialize($this->language->get('ideallite_payment_cancel')));
			      $this->redirect(HTTP_SERVER . 'index.php?route=checkout/success');
			    break;
			    case intval($this->config->get('ideallite_order_status_error_id')):
			      $this->load->model('checkout/order');
		        $this->load->model('payment/ideallite');
		        $this->load->language('payment/ideallite_error');
		        $this->session->data['payment_notice'] = base64_encode(serialize($this->language->get('ideallite_payment_error')));
		        $this->model_payment_ideallite->resetOrderStatusBeforeConfirm($this->session->data['order_id']);
	          $this->model_checkout_order->confirm($this->session->data['order_id'], intval($this->config->get('ideallite_order_status_error_id')), '', FALSE);
			      $this->redirect(HTTP_SERVER . 'index.php?route=checkout/success');
			    break;
			  }
			}
		}
		$this->redirect(HTTP_SERVER . 'index.php?route=checkout/cart');
	}

	protected function escapeHtml($string)
	{
		return str_replace(array('&', '"', '<', '>'), array('&amp;', '&quot;', '&lt;', '&gt;'), $string);
	}

}
?>