<?php
class ModelPaymentIdeallite extends Model {
  	public function getMethod($address) {
		$this->load->language('payment/ideallite');

		if ($this->config->get('ideallite_status')) {
			$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->config->get('ideallite_geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

      		if (!$this->config->get('ideallite_geo_zone_id')) {
        		$status = TRUE;
      		} elseif ($query->num_rows) {
        		$status = TRUE;
      		} else {
        		$status = FALSE;
      		}
		} else {
			$status = FALSE;
		}

		$method_data = array();

		if ($status) {
      		$method_data = array(
        		'id'         => 'ideallite',
        		'title'      => $this->language->get('text_title'),
				    'sort_order' => $this->config->get('ideallite_sort_order'),
				    'icon'       => $this->language->get('icon_title')
      		);
    	}

    	return $method_data;
  	}

  	public function get_aquirer()
		{
		  if(stripos($this->config->get('ideallite_mode'), 'prod') !== false) {
		    $mode = '';
		  } else {
		    $mode = 'test';
		  }

			if(stripos($this->config->get('ideallite_bank'), 'rabo') !== false) // Rabobank
			{
				$url_aquirer = 'https://ideal' . $mode . '.rabobank.nl/ideal/mpiPayInitRabo.do';
			}
			elseif(stripos($this->config->get('ideallite_bank'), 'ing') !== false) // ING Bank
			{
				$url_aquirer = 'https://ideal' . $mode . '.secure-ing.com/ideal/mpiPayInitIng.do';
			}
			elseif(stripos($this->config->get('ideallite_bank'), 'sim') !== false) // IDEAL SIMULATOR
			{
				$url_aquirer = 'https://www.ideal-simulator.nl/lite/';
			}
			return $url_aquirer;
		}

		public function getOrderData() {
		  $query = $this->db->query("SELECT o.total, o.currency, l.code FROM `" . DB_PREFIX . "order` o INNER JOIN " . DB_PREFIX . "language l ON (o.language_id = l.language_id) WHERE o.order_id = '" . $this->session->data['order_id'] . "'");
		  return $query->row['total'];
		}

  	public function getLanguageById($language_id) {
  	  $query = $this->db->query("SELECT l.status, l.code FROM " . DB_PREFIX . "language l WHERE l.language_id = '" . $language_id . "'");
  	  return $query->row['code'];
  	}

  	public function getProductNames() {
  	  $query = $this->db->query("SELECT op.name FROM " . DB_PREFIX . "order_product op WHERE op.order_id = '" . $this->session->data['order_id'] . "' limit 5");
  	  $description = '';
  	  foreach ($query->row as $result) {
  	    $description .= strip_tags($result) . ',';
  	  }
  	  $description = substr($description, 0, strlen($description) - 1);
  	  return substr($description, 0, 32);
  	}

  	public function setOrderStatusBeforePayment($order_id, $status_id) {
  		$order_query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order` o WHERE o.order_id = '" . (int)$order_id . "'");
		  if ($order_query->num_rows) {
 		    $this->load->language('payment/ideallite');
			  $this->db->query("UPDATE `" . DB_PREFIX . "order` SET order_status_id = '" . (int)$status_id . "', date_modified = NOW() WHERE order_id = '" . (int)$order_id . "'");
			  $this->db->query("INSERT INTO " . DB_PREFIX . "order_history SET order_id = '" . (int)$order_id . "', order_status_id = '" . (int)$status_id . "', notify = '0', comment = '" . $this->db->escape($this->language->get('set_order_status_before_payment')) . "', date_added = NOW()");
  		}
  	}

  	 public function resetOrderStatusBeforeConfirm($order_id) {
  		$order_query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order` o WHERE o.order_id = '" . (int)$order_id . "'");
		  if ($order_query->num_rows) {
 		    $this->load->language('payment/ideallite');
			  $this->db->query("UPDATE `" . DB_PREFIX . "order` SET order_status_id = '0', date_modified = NOW() WHERE order_id = '" . (int)$order_id . "'");
  		}
  	}
}
?>